//LptIO.dll
//#include <math.h>
#include <time.h>
#include <conio.h>
#include <Windows.h>
#include "DlPortIO.h"

//Variables globales
unsigned int 	ADR1=0x378;          

//________________________________________
//Prototypes -> Voir lptIO.def
void send_byte(unsigned char c);
unsigned char etat_port(void);
void out_port(long a,unsigned char c);
unsigned char in_port(long a);

//________________________________________
//Corps
void out_port(long a,unsigned char c)
{
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		//Registre de donnes: Offset+0: criture de l'octet
		_outp((unsigned short)a,c);
	}
	else
	{
		//PortIO pour XP
	  DlPortWritePortUchar(a,c);
	}
}
//________________________________________
unsigned char in_port(long a)
{
	unsigned char k;
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		k=_inp((unsigned short)a);
	}
	else
	{
		//PortIO pour XP
	  k=DlPortReadPortUchar(a);
	}
	return k;
}
//________________________________________
void send_byte(unsigned char c)
{
	out_port(ADR1,c);

	//Brochage port parallle (mode Centronics ou Standard mode "SPP")
	//N broche			Dfinition			In/Out	Description
	//		1						Strobe\					Out		Active low. Indicates valid data is on the data lines
	//	2  9					Data						Out		8 data lines. Output only in older SPP
	//		10					Ack 						In		A low asserted pulse to indicate that the last character was received
	//		11					Busy\						In		A high signal asserted by the printer to indicate that it is busy and cannot take data
	//		12					Paper Empty			In		
	//		13					Select					In		Asserted high o indicate that the printer is online
	//		14					Autofeed\				Out		Active low. Instructs the feed printer to automatically insert line feed for each carriage return
	//		15					Error						In		Signal by printer to the computer to indicate an error condition
	//		16					Init\						Out		Active low. Used to reset printer
	//		17					SelectIn\				Out		Active low. Used to indicate to the printer that it is selected
	//	18  25				Ground
	//		\:Actif au niveau bas

	//Dfinition des registres (mode Centronics ou Standard mode "SPP")
	//Nom port				Offset						Type			Description
	//SPP Data Port			+0								W				Standard SPP data port
	//SPP Status Port		+1								R				Reads the input line on the interface
	//SPP Control Port	+2								W				Sets the state of the output control lines

	//Dfinition des bits SPP Data Port (Offset+0)
	//Bit						Dfinition
	// 7						Data 7		(Pin9)
	// 6						Data 6		(Pin8)
	// ...										(Pin 6  7)	
	// 3						Data 3		(Pin5)
	// 2						Data 2		(Pin4)			Utilis ici pour CPU_RD
	// 1						Data 1		(Pin3)			Utilis ici pour CPU_RES
	// 0						Data 0		(Pin2)			Utilis ici pour CPU_CLK

	//Dfinition des bits SPP Status Port (Offset+1) (R)
	//Bit						Dfinition
	// 7						Busy\			(Pin11)
	// 6						Ack				(Pin10)
	// 5						Paper Out	(Pin12)
	// 4						Select In	(Pin13)			Utilis ici pour l'entre de l'tat des pixels
	// 3						Error			(Pin15)
	// 2						IRQ (Not)
	// 1						Reserved
	// 0						Reserved

	//Dfinition des bits SPP Control Port (Offset+2) (W)
	//Bit						Dfinition
	// 7						Unused
	// 6						Unused
	// 5						Enable bi-directional port
	// 4						Enable IRQ via Ack Line
	// 3						Select printer\						(Pin17)
	// 2						Reset printer\						(Pin16)
	// 1						Auto linefeed\						(Pin14)
	// 0						Strobe\										(Pin1)
 }
//________________________________________
unsigned char etat_port(void)
{
	return in_port(ADR1+1);
	/*
	Dfinition des bits SPP Status Port (Offset+1) (R)
	7  6  5  4  3  2  1  0  Signification
	1  -  -  -  -  -  -  -  BUSY\: Imprimante libre (Pin11)
	-  1  -  -  -  -  -  -  ACK: Reconnaissance par l'imprimante (Pin10)
	-  -  1  -  -  -  -  -  PAPER OUT: Plus de papier (Pin12)

	-  -  -  1  -  -  -  -  SELECT IN: Slectionne (0=non slectionne) (Pin13): utilis ici pour l'tat des pixels

	-  -  -  -  1  -  -  -  ERROR: I/O Erreur (Pin15)
	-  -  -  -  -  x  -  -  IRQ
	-  -  -  -  -  -  x  -  Non utilis
	-  -  -  -  -  -  -  x  Non utilis
	*/
}
//________________________________________
